//  ----------------------------------------------------------
//
//  Copyright (C) 2002 Brad Wasson <bard@systemtoolbox.com>
//
//  This file is part of 3ddesktop.
//
//  3ddesktop is free software; you can redistribute it and/or modify it
//  under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2, or (at your option)
//  any later version.
//
//  3ddesktop is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with 3ddesktop; see the file COPYING.   If not, write to
//  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
#ifndef _3DDESK_H
#define _3DDESK_H

// FIXME: use dynamic allocation...
#define MAX_FACES  12  // no human could need more... 

#define PI         3.141592654
#define FOV        60.0   // field of view

#define MAX_FILTER GL_LINEAR // scale linearly when image bigger than texture
#define MIN_FILTER GL_LINEAR_MIPMAP_LINEAR

#define MTYPE_ACTIVATE    1


// range 1 thru MAX_FACES -- goto that face
// 0 -- no goto
// -1 -- goto next
// -2 -- goto previous
#define NO_GOTO         0
#define GOTO_NEXT_FACE -1
#define GOTO_PREV_FACE -2


#define FACE_TYPE_CYL           1
#define FACE_TYPE_LINEAR        2
#define FACE_TYPE_VIEWMASTER    3
#define FACE_TYPE_CAROUSEL      4
#define FACE_TYPE_PRICEISRIGHT  5


/* used in message passing with 3ddesktop daemon */
struct threedeedesk_command {
    long mtype;
    int goto_face;
    int zoom;
    int face_type;
};


#define DEBUG 1
#define INFO  2
#define ERROR 3

void msgout (int level, char *msg, ...);
void end_program (int rv);

#endif // _3DDESK_H
